<?php
/*
Plugin Name: Add AWeber To Commerce Manager
Plugin URI: https://www.kleor.com/commerce-manager/
Description: Adds AWeber to Commerce Manager.
Version: 1.0
Author: Kleor
Author URI: https://www.kleor.com
Text Domain: commerce-manager
*/


function add_aweber_to_commerce_manager($autoresponders) {
$autoresponders['AWeber'] = array(
'function' => 'subscribe_to_aweber',
'display_function' => 'display_aweber',
'update_function' => 'update_aweber');
return $autoresponders; }

add_filter('commerce_autoresponders', 'add_aweber_to_commerce_manager');


function subscribe_to_aweber($list, $contact) {
$original_list = $list;
$contact['first_name'] = kleor_strip_accents($contact['first_name']);
$array = explode('|', commerce_data('aweber_api_key'));
if (count($array) != 4) { $email_parser = true; }
else {
$email_parser = false;
list($consumerKey, $consumerSecret, $accessToken, $accessSecret) = $array;
try {
if (!class_exists('AWeberAPI')) { include_once dirname(__FILE__).'/aweber.php'; }
$aweber = new AWeberAPI($consumerKey, $consumerSecret);
$account = $aweber->getAccount($accessToken, $accessSecret);
if (!is_numeric(str_replace('awlist', '', $list))) {
$lists = $account->lists->find(array('name' => $list))->data;
if ((isset($lists['entries'])) && (isset($lists['entries'][0])) && (isset($lists['entries'][0]['id']))) { $list = $lists['entries'][0]['id']; } else { $email_parser = true; } }
if (!$email_parser) {
$list = $account->loadFromUrl('/accounts/'.$account->id.'/lists/'.preg_replace('/[^0-9]/', '', $list));
$list->subscribers->create(array(
'email' => $contact['email_address'],
'name' => $contact['first_name'],
'ip_address' => $contact['ip_address'],
'ad_tracking' => $contact['referrer'])); } }
catch(Exception $exc) { $email_parser = true; } }
if ($email_parser) {
$list = $original_list;
if (is_numeric($list)) { $list = 'awlist'.$list; }
$list = str_replace('à', '@', $list);
if (!strstr($list, '@')) { $list = $list.'@aweber.com'; }
$subject = 'AWeber Subscription';
$body =
"\nEmail: ".$contact['email_address'].
"\nName: ".$contact['first_name'].
"\nReferrer: ".$contact['referrer'];
$domain = $_SERVER['SERVER_NAME'];
if (substr($domain, 0, 4) == 'www.') { $domain = substr($domain, 4); }
if (strlen($domain) < 36) { $sender = 'wordpress@'.$domain; } else { $sender = 'w@'.$domain; }
foreach (array($sender, $contact['first_name'].' <'.$contact['email_address'].'>') as $string) {
mail($list, $subject, $body, 'From: '.$string); } } }


function display_aweber($options, $back_office_options) { ?>
<table class="form-table"><tbody>
<tr style="vertical-align: top;"><th scope="row" style="width: 20%;"><strong><label for="aweber_api_key"><?php _e('API key', 'commerce-manager'); ?></label></strong></th>
<td><textarea style="float: left; margin-right: 1em; width: 50%;" name="aweber_api_key" id="aweber_api_key" rows="2" cols="50"><?php echo $options['aweber_api_key']; ?></textarea> 
<span class="description"><a target="<?php echo $back_office_options['documentations_links_target']; ?>" href="https://www.kleor.com/commerce-manager/documentation/#aweber"><?php _e('More informations', 'commerce-manager'); ?></a></span></td></tr>
<tr style="vertical-align: top;"><th scope="row" style="width: 20%;"></th>
<td><input type="submit" class="button-secondary" name="submit" value="<?php _e('Update', 'commerce-manager'); ?>" /></td></tr>
</tbody></table>
<?php }


function update_aweber($options) {
if (isset($_POST['aweber_api_key'])) {
$_POST['aweber_api_key'] = trim($_POST['aweber_api_key']);
if ((isset($_POST['submit'])) && (substr_count($_POST['aweber_api_key'], '|') > 3)) {
if (!class_exists('AWeberAPI')) { include_once dirname(__FILE__).'/aweber.php'; }
$array = AWeberAPI::getDataFromAweberID($_POST['aweber_api_key']);
if ((is_array($array)) && (count($array) == 4)) { $_POST['aweber_api_key'] = $array[0].'|'.$array[1].'|'.$array[2].'|'.$array[3]; } }
$options['aweber_api_key'] = $_POST['aweber_api_key']; }
return $options; }